#include <a_samp>
#include <a_mysql>
#include <dc_cmd>
#include <sscanf2>
#include <streamer>
#include <mxdate>

/*COLORS*/
const WHITE = 		0xFFFFFFAA;
const GREY = 		0xAFAFAFAA;
const RED = 		0xFF0000AA;
const YELLOW = 		0xFFFF00AA;
const LIGHTBLUE = 	0x33CCFFAA;

#define CHAT_WHITE 		"{FFFFFF}"
#define CHAT_GREY 		"{AFAFAF}"
#define CHAT_RED 		"{FF0000}"
#define CHAT_YELLOW 	"{FFFF00}"
#define CHAT_LIGHTBLUE 	"{33CCFF}"

/*SQL*/
#define SQL_HOST 	"localhost"
#define SQL_DB 		"test"
#define SQL_USER 	"root"
#define SQL_PASS 	"root"

/*FORWARDS*/
forward OnCheckPlayerBan (playerid, status);
forward OnPlayerDataLoaded(playerid, race_check);
forward OnPlayerRegister(playerid);
forward _KickPlayerDelayed(playerid);
forward OnPlayerCheckRPTest (playerid, isparam);
forward OnAccountChangeStatus (playerid, status);
forward SecondTimer ();

/*GLOBAL_VARS*/
new g_SQL = -1;
new g_MysqlRaceCheck [MAX_PLAYERS];
new g_Current_RP_Questuion_Step [MAX_PLAYERS char];
new g_RP_Status [MAX_PLAYERS char];
new g_Current_Hour;
new g_Spawn_Change [MAX_PLAYERS char];
new g_Players [MAX_PLAYERS];
new g_Players_Count;

const g_Max_Fractions = 1;
/*PICKUPS*/
new g_p_Bank = -1;

/*GLOBAL_ARRAYS*/
static const g_Reg_Questions [][] = {
	{"       ?"},
	{""},
	{"       ?"},
	{"       , ,    ."},
	{"        ,    ,  ?"},
	{"   ?"},
	{"   "}
};

static const g_Admin_Rank_Names [][] = {
	{" 1 "},
	{" 2 "},
	{" 3 "}
};

/*ENUMS*/
enum E_PLAYER {
	ID,
	Name[MAX_PLAYER_NAME],
	Password[129],
	Money,
	Sex,
	Skin,
	Admin,
	Level,
	Exp,
	Member,
	Leader,
	Bank,
	Rank,
	Warn,

	bool:IsLoggedIn,
	bool:IsRegistered,
	LoginAttempts
};
new Player[MAX_PLAYERS][E_PLAYER];

enum E_FRACTIONS {
	ID,
	Name [32],
Float:SpawnCoords[3],
	Interior,
	Skin[13]
};
new Fractions[g_Max_Fractions][E_FRACTIONS],
	Rank_Name[g_Max_Fractions][13][32];

enum {
	DIALOG_INVALID = 1,
	DIALOG_UNUSED = 1,

	DIALOG_LOGIN = 2,
	DIALOG_REGISTER = 3,
	
	DIALOG_SELECT_SEX = 4,
	
	DIALOG_RP_QUESTIONS = 5, /*+6*/
	DIALOG_TRY_RP_TEST = 12, /*+1*/
	DIALOG_BANK = 14 /*+3*/
};

/*BEGIN_SCRIPT*/
main() { }
public OnGameModeInit() {
	SetGameModeText("Blank Script");
	mysql_log(LOG_ERROR | LOG_WARNING | LOG_DEBUG, LOG_TYPE_TEXT);
	g_SQL = mysql_connect(SQL_HOST, SQL_USER, SQL_DB, SQL_PASS);
 	printf ("   MySQL %s", (g_SQL) ? ("") : (" "));
	
	ShowPlayerMarkers(1);
	ShowNameTags(1);
	gettime(g_Current_Hour);
	SetWorldTime(g_Current_Hour);
	SetTimer("SecondTimer", 1000, true);
	
	mysql_tquery(g_SQL, "SELECT * FROM `fractions`", "OnFractionLoad", "");
	
	g_p_Bank = CreateDynamicPickup (1274, 23,
	    2381.9077, -1911.5232, 22.6751, -1);
	return 1;
}

public OnGameModeExit() {
	for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
		UpdatePlayerData(i);
	}
	DestroyDynamicPickup (g_p_Bank);
	mysql_close();
	return 1;
}

public OnPlayerRequestClass(playerid, classid)
{
	return 1;
}

public OnPlayerConnect(playerid) {
	g_Players[g_Players_Count++] = playerid;
	g_MysqlRaceCheck[playerid]++;
	g_Current_RP_Questuion_Step {playerid} = 0;
	g_RP_Status {playerid} = 0;
	g_Spawn_Change {playerid} = 0;

	for(new E_PLAYER:e; e < E_PLAYER; ++e)
	    Player[playerid][e] = 0;
	    
 	new query[128];
	GetPlayerName(playerid, Player[playerid][Name], MAX_PLAYER_NAME);
	mysql_format(g_SQL, query, sizeof(query),
		"SELECT * FROM `banlist` WHERE `name` = '%e' LIMIT 1",
		Player[playerid][Name]);
	mysql_tquery(g_SQL, query, "OnCheckPlayerBan", "dd", playerid, -1);
	return 1;
}

public OnPlayerDisconnect(playerid, reason) {
    for(new i = 0; i < g_Players_Count; i++) {
        if (g_Players[i] == playerid){
            g_Players[i] = g_Players [--g_Players_Count];
            g_Players[g_Players_Count] = -1;
            break;
        }
    }
    g_MysqlRaceCheck[playerid]++;
	UpdatePlayerData(playerid);
	return 1;
}

public OnPlayerSpawn(playerid) {
	ResetPlayerMoney(playerid);
	GivePlayerMoney(playerid, Player[playerid][Money]);
	SetPlayerSkin (playerid, Player[playerid][Skin]);
	new member = Player [playerid] [Member];
	if (member > 0) {
	    SetPlayerSkin (playerid,
			Fractions[member - 1][Skin][Player[playerid][Rank] - 1]);
		if (g_Spawn_Change {playerid} == 1) {
		    SetPlayerPos (playerid,
		        -2277.5967, 244.0082, 24.5153);
		} else {
		    SetPlayerPos (playerid,
		        Fractions[member - 1][SpawnCoords][0],Fractions[member - 1][SpawnCoords][1],Fractions[member - 1][SpawnCoords][2]);
			SetPlayerInterior (playerid,
			    Fractions[member - 1][Interior]);
		}
    } else {
		SetPlayerPos (playerid,
			-2277.5967,244.0082,24.5153);
    }
	return 1;
}

public OnPlayerDeath(playerid, killerid, reason)
{
	return 1;
}

public OnVehicleSpawn(vehicleid)
{
	return 1;
}

public OnVehicleDeath(vehicleid, killerid)
{
	return 1;
}

public OnPlayerText(playerid, text[]) {
	if (Player[playerid][IsLoggedIn] == false) return 0;
	new Float:x, Float:y, Float:z;
    GetPlayerPos(playerid, x, y, z);
    new string [128];
    for(new i = GetMaxPlayers() - 1, Float:dist, virtualworld = GetPlayerVirtualWorld(playerid), interior = GetPlayerInterior(playerid); i != -1; i--)
	{
	    if(!IsPlayerConnected(i) || IsPlayerNPC(i) || virtualworld != GetPlayerVirtualWorld(i) || interior != GetPlayerInterior(i)) continue;
     	dist = GetPlayerDistanceFromPoint(i, x, y, z);
        if(dist < 15 / 12) format(string, sizeof (string), "{999999}%s (%i):{ffffff} %s", Player[playerid][Name], playerid, text);
        else if(dist < 15 / 8) format(string, sizeof (string), "{999999}%s (%i):{C4C4C4} %s", Player[playerid][Name], playerid, text);
        else if(dist < 15 / 4) format(string, sizeof (string), "{999999}%s (%i):{ABABAB} %s", Player[playerid][Name], playerid, text);
        else if(dist < 15 / 2) format(string, sizeof (string), "{999999}%s (%i):{969696} %s", Player[playerid][Name], playerid, text);
        else if(dist < 15) format(string, sizeof (string), "{999999}%s (%i):{666666} %s", Player[playerid][Name], playerid, text);
        if(dist < 15) SendClientMessage(i, -1, string);
        SetPlayerChatBubble(playerid, text,0xFFFFFFAA, 15.0, 3000);
	}
	return 0;
}

public OnPlayerEnterVehicle(playerid, vehicleid, ispassenger)
{
	return 1;
}

public OnPlayerExitVehicle(playerid, vehicleid)
{
	return 1;
}

public OnPlayerStateChange(playerid, newstate, oldstate)
{
	return 1;
}

public OnPlayerEnterCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveCheckpoint(playerid)
{
	return 1;
}

public OnPlayerEnterRaceCheckpoint(playerid)
{
	return 1;
}

public OnPlayerLeaveRaceCheckpoint(playerid)
{
	return 1;
}

public OnRconCommand(cmd[])
{
	return 1;
}

public OnPlayerRequestSpawn(playerid)
{
	return 1;
}

public OnObjectMoved(objectid)
{
	return 1;
}

public OnPlayerObjectMoved(playerid, objectid)
{
	return 1;
}

public OnPlayerPickUpDynamicPickup(playerid, pickupid) {
	if (pickupid == g_p_Bank) {
	    ShowPlayerDialog (playerid, DIALOG_BANK, DIALOG_STYLE_LIST,
	        "", "\n\n\n ",
			"", "");
		return 1;
	}
	return 1;
}

public OnVehicleMod(playerid, vehicleid, componentid)
{
	return 1;
}

public OnVehiclePaintjob(playerid, vehicleid, paintjobid)
{
	return 1;
}

public OnVehicleRespray(playerid, vehicleid, color1, color2)
{
	return 1;
}

public OnPlayerSelectedMenuRow(playerid, row)
{
	return 1;
}

public OnPlayerExitedMenu(playerid)
{
	return 1;
}

public OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid)
{
	return 1;
}

public OnPlayerKeyStateChange(playerid, newkeys, oldkeys)
{
	return 1;
}

public OnRconLoginAttempt(ip[], password[], success)
{
	return 1;
}

public OnPlayerUpdate(playerid)
{
	return 1;
}

public OnPlayerStreamIn(playerid, forplayerid)
{
	return 1;
}

public OnPlayerStreamOut(playerid, forplayerid)
{
	return 1;
}

public OnVehicleStreamIn(vehicleid, forplayerid)
{
	return 1;
}

public OnVehicleStreamOut(vehicleid, forplayerid)
{
	return 1;
}

public OnDialogResponse(playerid, dialogid, response, listitem, inputtext[])
{
	if(dialogid == DIALOG_INVALID || dialogid == DIALOG_UNUSED)
		return 1;

	switch(dialogid) {
	    case DIALOG_LOGIN: {
	        if(!response)
	            return Kick(playerid);

			if(strlen(inputtext) <= 5)
				return ShowPlayerDialog(playerid, DIALOG_LOGIN, DIALOG_STYLE_PASSWORD, "",
					CHAT_RED "     5 !\n" CHAT_WHITE "   .",
					"", "");

			if(strcmp(inputtext, Player[playerid][Password]) == 0) {
			    switch (g_RP_Status {playerid}) {
			        case 0: {
				        ShowPlayerDialog(playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
							"RP ", " RP     !",
							"", "");
				        DelayedKick (playerid);
			        }
			        case 1: {
						ShowPlayerDialog(playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
							"", "{FFFFFF}   .",
							"", "");
						Player[playerid][IsLoggedIn] = true;
			    		SetSpawnInfo(playerid, 0, 0, -2277.5967,244.0082,24.5153, 0.0, 0, 0, 0, 0, 0, 0);
						SpawnPlayer(playerid);
			        }
			        case 2: {
       					ShowPlayerDialog(playerid, DIALOG_TRY_RP_TEST, DIALOG_STYLE_MSGBOX,
						   "RP ", " RP   .   RP  ?",
						   "", "");
			        }
				}
			} else {
			    Player[playerid][LoginAttempts]++;
			    if(Player[playerid][LoginAttempts] >= 3) {
					ShowPlayerDialog(playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX, "", CHAT_RED "    3 .", "", "");
			        DelayedKick(playerid);
				}
				else
   					ShowPlayerDialog(playerid, DIALOG_LOGIN, DIALOG_STYLE_PASSWORD, "", CHAT_RED " !\n" CHAT_WHITE "   .", "", "");
			}
	    }

	    case DIALOG_REGISTER: {
	        if(!response)
	            return Kick(playerid);

            if(strlen(inputtext) <= 5)
				return ShowPlayerDialog(playerid, DIALOG_REGISTER, DIALOG_STYLE_PASSWORD, "",
					CHAT_RED "     5 !\n" CHAT_WHITE "   .",
					"", "");

			new query[256];
			mysql_format(g_SQL, query, sizeof(query), "INSERT INTO `players` (`username`, `password`) VALUES ('%e', '%s')", Player[playerid][Name], inputtext);
			mysql_tquery(g_SQL, query, "OnPlayerRegister", "d", playerid);
	    }
	    case DIALOG_SELECT_SEX: {
			if (response == 0)
			    return ShowPlayerDialog(playerid, DIALOG_SELECT_SEX, DIALOG_STYLE_MSGBOX, " ",
					CHAT_WHITE "  ", "", "");
						
			Player [playerid] [Sex] = response + 1;
			Player [playerid] [Skin] = (response) ? 119 : 142;

			new query [128];
			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `sex` = '%d', `skin` = '%d', `level` = '1' WHERE `id` = '%d' LIMIT 1", Player [playerid] [Sex], Player [playerid] [Skin], Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS, DIALOG_STYLE_INPUT,
			     CHAT_RED "1" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
				"", "");
		}
		case DIALOG_RP_QUESTIONS: {
		    if (response == 0)
		        return Kick (playerid);
			if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS, DIALOG_STYLE_INPUT,
						CHAT_RED "1" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
			g_Current_RP_Questuion_Step {playerid} = 2;
			new title[32],
				query [128];
				
			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_1` = '%s' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			format (title, sizeof (title), CHAT_RED "%d" CHAT_WHITE "/6", g_Current_RP_Questuion_Step {playerid});
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + g_Current_RP_Questuion_Step {playerid}, DIALOG_STYLE_INPUT,
			    title, g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
				"", "");
		}
		case DIALOG_RP_QUESTIONS + 2: {
			if (response == 0)
		        return Kick (playerid);
		        
			if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + 2, DIALOG_STYLE_INPUT,
						CHAT_RED "2" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
						
			g_Current_RP_Questuion_Step {playerid}++;
			new title[32],
				query [128];
				
			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_2` = '%s' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			
			format (title, sizeof (title), CHAT_RED "%d" CHAT_WHITE "/6", g_Current_RP_Questuion_Step {playerid});
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + g_Current_RP_Questuion_Step {playerid}, DIALOG_STYLE_INPUT,
			    title, g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
				"", "");
		}
		case DIALOG_RP_QUESTIONS + 3: {
			if (response == 0)
		        return Kick (playerid);
		        
			if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + 3, DIALOG_STYLE_INPUT,
						CHAT_RED "3" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
						
			g_Current_RP_Questuion_Step {playerid}++;
			new title [32],
				query [128];
				
			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_3` = '%s' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			format (title, sizeof (title), CHAT_RED "%d" CHAT_WHITE "/6", g_Current_RP_Questuion_Step {playerid});
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + g_Current_RP_Questuion_Step {playerid}, DIALOG_STYLE_INPUT,
			    title, g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
				"", "");
		}
		case DIALOG_RP_QUESTIONS + 4: {
			if (response == 0)
		        return Kick (playerid);
		        
			if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + 4, DIALOG_STYLE_INPUT,
						CHAT_RED "4" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
						
			g_Current_RP_Questuion_Step {playerid}++;
			new title [32],
				query [128];

			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_4` = '%s' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			format (title, sizeof (title), CHAT_RED "%d" CHAT_WHITE "/6", g_Current_RP_Questuion_Step {playerid});
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + g_Current_RP_Questuion_Step {playerid}, DIALOG_STYLE_INPUT,
			    title, g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
		 		"", "");
		}
		case DIALOG_RP_QUESTIONS + 5: {
			if (response == 0)
		        return Kick (playerid);
		        
			if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + 5, DIALOG_STYLE_INPUT,
						CHAT_RED "5" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
						
			g_Current_RP_Questuion_Step {playerid}++;
			new title [32],
				query [128];

			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_5` = '%s' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			format (title, sizeof (title), CHAT_RED "%d" CHAT_WHITE "/6", g_Current_RP_Questuion_Step {playerid});
			ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + g_Current_RP_Questuion_Step {playerid}, DIALOG_STYLE_INPUT,
			    title, g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
				"", "");
		}
		case DIALOG_RP_QUESTIONS + 6: {
			if (response == 0)
		        return Kick (playerid);
		        
            if (strlen (inputtext) > 126)
			    return 	ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS + 6, DIALOG_STYLE_INPUT,
						CHAT_RED "6" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
						"", "");
						
			new query [128];
			mysql_format(g_SQL, query, sizeof(query),
				"UPDATE `players` SET `question_6` = '%s' , `rpstatus` = '0' WHERE `id` = '%d' LIMIT 1", inputtext, Player[playerid][ID]);
			mysql_tquery(g_SQL, query);
			ShowPlayerDialog (playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
			    "RP  ", "Role Play  , ,      ,      !",
				"", "");
            DelayedKick (playerid);
		}
		case DIALOG_TRY_RP_TEST: {
		    if (response == 0) {
		        ShowPlayerDialog (playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
					"RP ", "     RP !",
					"", "");
				DelayedKick (playerid);
		    } else {
			    ShowPlayerDialog (playerid, DIALOG_RP_QUESTIONS, DIALOG_STYLE_INPUT,
					CHAT_RED "1" CHAT_WHITE "/6", g_Reg_Questions [g_Current_RP_Questuion_Step {playerid}],
					"", "");
			}
		}
		case DIALOG_BANK: {
		    if (response == 0)
		        return 1;
			switch (listitem) {
			    case 0:
			        ShowPlayerDialog (playerid, DIALOG_BANK + 1, DIALOG_STYLE_INPUT,
			            "  ", CHAT_WHITE" - ,      !",
			            "", "");
			    case 1:
			        ShowPlayerDialog (playerid, DIALOG_BANK + 2, DIALOG_STYLE_INPUT,
			            "  ", CHAT_WHITE" - ,      !",
			            "", "");
			    case 2:
				    ShowPlayerDialog (playerid, DIALOG_BANK + 3, DIALOG_STYLE_INPUT,
				            "  ", CHAT_WHITE" ID   - ( ),      !\n\
							: 1,100 ( 1 - ID , 100 - - )",
				            "", "");
			    case 3: {
			        new string [128];
			        format (string, sizeof (string),
						CHAT_WHITE"   : "CHAT_RED"%d$",
						Player [playerid][Bank]);
			        ShowPlayerDialog (playerid,	DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
			            "", string,
			            "", "");
				}
			}
		}
		case DIALOG_BANK + 1: {
		    if (response == 0)
		        return 1;
			new money = strval (inputtext);
			if (money > Player [playerid][Bank])
			    return SendClientMessage (playerid, -1,
			        " !");
			Player [playerid][Money] += money;
			Player [playerid][Bank] -= money;
			new string [128];
			format (string, sizeof (string),
				"    %d.",
				money);
			SendClientMessage (playerid, -1,
			    string);
		}
		case DIALOG_BANK + 2: {
		    if (response == 0)
		        return 1;
			new money = strval (inputtext);
			if (money > Player [playerid][Money])
			    return SendClientMessage (playerid, -1,
			        " !");
			Player [playerid][Money] -= money;
			Player [playerid][Bank] += money;
			new string [128];
			format (string, sizeof (string),
				"      %d.",
				money);
			SendClientMessage (playerid, -1,
			    string);
		}
		case DIALOG_BANK + 3: {
		    if (response == 0)
		        return 1;
			new transfer,
				id;
            if (sscanf(inputtext, "p<,>ii", id, transfer)) {
				return 	ShowPlayerDialog (playerid, DIALOG_BANK + 3, DIALOG_STYLE_INPUT,
				            "  ", CHAT_WHITE" ID   - ( ),      !\n\
							: 1,100 ( 1 - ID , 100 - - )",
				            "", "");
            }
            if (id == playerid)
                return SendClientMessage (playerid, -1,
                    "    .");
			if (transfer > Player [playerid][Bank])
			    return SendClientMessage (playerid, -1,
			        " !");
            if (Player[id][IsLoggedIn] == false)
                return SendClientMessage (playerid, -1,
                    "  .");
			Player [playerid][Bank] -= transfer;
			Player [id][Bank] += transfer;
			new string [128];
			format (string, sizeof (string),
				"    %s  %d.",
				Player [id][Name], transfer);
			SendClientMessage (playerid, -1,
			    string);
            format (string, sizeof (string),
				" %s       %d.",
				Player [playerid][Name], transfer);
			SendClientMessage (id, -1,
			    string);
		}
	    default:
			return 0;
	}
	return 1;
}

public OnPlayerClickPlayer(playerid, clickedplayerid, source)
{
	return 1;
}

public OnCheckPlayerBan (playerid, status) {
	if (status == -1) {
		if (cache_num_rows() > 0) {
		    new bantime,
				unbantime,
				PlayerBan[MAX_PLAYER_NAME],
				reason[128];

	        cache_get_field_content(0, "reason", reason, g_SQL, 128);
	        cache_get_field_content(0, "playerban", PlayerBan, g_SQL, MAX_PLAYER_NAME);
			bantime = cache_get_field_content_int(0, "bantime");
			unbantime = cache_get_field_content_int(0, "unbantime");
			if (gettime() >= unbantime) {
		 		UnBan (Player[playerid][Name]);
		 		new query [128];
		 		mysql_format(g_SQL, query, sizeof(query), "SELECT * FROM `players` WHERE `username` = '%e' LIMIT 1", Player[playerid][Name]);
				mysql_tquery(g_SQL, query, "OnPlayerDataLoaded", "dd", playerid, g_MysqlRaceCheck[playerid]);
				return 1;
			}
			new string [256];
			format(string, sizeof(string),
				"{FFFFFF}\
				 : %s\n\
	             : %s\n\
	            : %s\n\
	             : %s\n",
	            date("%dd.%mm.%yyyy  %hh:%ii:%ss", bantime),
	            date("%dd.%mm.%yyyy  %hh:%ii:%ss", unbantime),
	            PlayerBan, reason);
	        ShowPlayerDialog (playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
				" ", string,
				"", "");
	        DelayedKick (playerid);
		} else {
	    	new query [128];
		 	mysql_format(g_SQL, query,
				sizeof(query), "SELECT * FROM `players` WHERE `username` = '%e' LIMIT 1", Player[playerid][Name]);
			mysql_tquery(g_SQL, query, "OnPlayerDataLoaded", "dd", playerid, g_MysqlRaceCheck[playerid]);
		}
	} else {
	    if (cache_num_rows() > 0) {
	        new name [MAX_PLAYER_NAME];
	        cache_get_field_content(0, "name", name, g_SQL, MAX_PLAYER_NAME);
	        UnBan (name);
	        SendClientMessage (playerid, -1,
	            "   !");
	    } else {
	        SendClientMessage (playerid, -1,
	            "  !");
	    }
	}
	return 1;
}

stock UnBan (playername []) {
	new query [128];
	mysql_format(g_SQL, query, sizeof (query),
	    "DELETE FROM `banlist` WHERE `name` = '%e'",
	    playername);
    mysql_tquery(g_SQL, query);
}

public OnPlayerDataLoaded(playerid, race_check) {
	if(race_check != g_MysqlRaceCheck[playerid])
	    return Kick(playerid);

    new string[128];
	if(cache_num_rows() > 0) {
        AssignPlayerData(playerid);

		format(string, sizeof(string),
			CHAT_WHITE " (" CHAT_YELLOW "%s" CHAT_WHITE ") .    .",
			Player[playerid][Name]);
		ShowPlayerDialog(playerid, DIALOG_LOGIN, DIALOG_STYLE_PASSWORD,
			"", string,
			"", "");
		Player[playerid][IsRegistered] = true;
	} else {
		format(string, sizeof(string),
			CHAT_WHITE "  " CHAT_YELLOW "%s" CHAT_WHITE ",     .",
			Player[playerid][Name]);
		ShowPlayerDialog(playerid, DIALOG_REGISTER, DIALOG_STYLE_PASSWORD,
			"", string,
			"", "");
		Player[playerid][IsRegistered] = false;
	}
	return 1;
}

public OnPlayerRegister(playerid) {
	Player[playerid][ID] = cache_insert_id();
	Player[playerid][IsRegistered] = true;
	return ShowPlayerDialog(playerid, DIALOG_SELECT_SEX, DIALOG_STYLE_MSGBOX, " ",
			CHAT_WHITE "  ",
			"", "");
}

stock AssignPlayerData(playerid) {
	Player[playerid][ID] = cache_get_field_content_int(0, "id");
	cache_get_field_content(0, "password", Player[playerid][Password], g_SQL, 129);
	Player[playerid][Money] = cache_get_field_content_int(0, "money");
	Player[playerid][Sex] = cache_get_field_content_int (0, "sex");
	g_Spawn_Change {playerid} = cache_get_field_content_int (0, "spawnchange");
	Player[playerid][Skin] = cache_get_field_content_int (0, "skin");
	Player[playerid][Admin] = cache_get_field_content_int (0, "admin");
	Player[playerid][Level] = cache_get_field_content_int (0, "level");
	Player[playerid][Exp] = cache_get_field_content_int (0, "exp");
    Player[playerid][Bank] = cache_get_field_content_int (0, "bank");
    Player[playerid][Member] = cache_get_field_content_int (0, "member");
    Player[playerid][Leader] = cache_get_field_content_int (0, "leader");
    Player[playerid][Rank] = cache_get_field_content_int (0, "rank");
    Player[playerid][Warn] = cache_get_field_content_int (0, "warn");
	g_RP_Status {playerid} = cache_get_field_content_int (0, "rpstatus");
	SetPlayerScore(playerid, Player[playerid][Level]);
	return 1;
}

stock UpdatePlayerData(playerid) {
	if(Player[playerid][IsLoggedIn] == false)
	    return 0;

	new query[512];
	mysql_format(g_SQL, query, sizeof (query),
		"UPDATE `players` SET `money` = '%d', `skin` = '%d', `spawnchange` = '%d', `admin` = '%d', `level` = '%d', `exp` = '%d', \
		`leader` = '%d', `member` = '%d', `bank` = '%d', `rank` = '%d', `warn` = '%d' WHERE `id` = '%d' LIMIT 1",
		Player[playerid][Money], Player[playerid][Skin], g_Spawn_Change {playerid}, Player[playerid][Admin],
	 	Player[playerid][Level], Player[playerid][Exp], Player[playerid][Leader], Player[playerid][Member],
	 	Player[playerid][Bank], Player[playerid][Rank], Player[playerid][Warn], Player[playerid][ID]);
	mysql_tquery(g_SQL, query);
	return 1;
}

stock DelayedKick(playerid, time = 500) {
	SetTimerEx("_KickPlayerDelayed", time, false, "d", playerid);
	return 1;
}

public _KickPlayerDelayed(playerid) {
	Kick(playerid);
	return 1;
}

public OnAccountChangeStatus (playerid, status) {
    if (cache_num_rows() > 0) {
		new name [MAX_PLAYER_NAME];
 		cache_get_field_content(0, "username", name, g_SQL, MAX_PLAYER_NAME);

 		new query [128];
 		mysql_format(g_SQL, query, sizeof (query),
			"UPDATE `players` SET `rpstatus` = '%d' WHERE `username` = '%e' LIMIT 1",
			status, name);
		mysql_tquery(g_SQL, query);
		format (query, sizeof (query),
		    " %s   %s!",
			name, (status == 1) ? ("") : (""));
		SendClientMessage (playerid, -1,
		    query);
    } else {
        SendClientMessage (playerid, -1,
            "   !");
    }
	return 1;
}

public OnPlayerCheckRPTest (playerid, isparam) {
	if (isparam == 0) {
	    if (cache_num_rows() > 0) {
	        SendClientMessage (playerid, -1,
	            ",  :");
	        for (new i = 0; i < cache_num_rows (); i++) {
	            new name [MAX_PLAYER_NAME];
	        	cache_get_field_content(0, "username", name, g_SQL, MAX_PLAYER_NAME);
	        	SendClientMessage (playerid, -1,
					name);
	        }
	    } else {
	        SendClientMessage (playerid, -1,
	            "   !");
	    }
	} else {
	    if (cache_num_rows() > 0) {
		    new questions [6][128];
		    cache_get_field_content(0, "question_1", questions[0], g_SQL, 128);
		    cache_get_field_content(0, "question_2", questions[1], g_SQL, 128);
		    cache_get_field_content(0, "question_3", questions[2], g_SQL, 128);
		    cache_get_field_content(0, "question_4", questions[3], g_SQL, 128);
		    cache_get_field_content(0, "question_5", questions[4], g_SQL, 128);
		    cache_get_field_content(0, "question_6", questions[5], g_SQL, 128);
			new source [128 * 6 + 50];
			format (source, sizeof (source),
				"{FFFFFF}\
				1) %s\n\
				2) %s\n\
				3) %s\n\
				4) %s\n\
				5) %s\n\
				6) %s",
				questions[0], questions[1], questions[2], questions[3], questions[4], questions[5]);
			ShowPlayerDialog (playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
			    "RP  ( )", source,
				"", "");
		}
	}
    return 1;
}

forward OnFractionLoad ();
public OnFractionLoad () {
	if (cache_num_rows() > 0) {
		new i;
	    for (i = 0; i < g_Max_Fractions; i++) {
	        new spawn [128],
				skins [128];
	        Fractions[i][ID] = cache_get_field_content_int(0, "id");
	        cache_get_field_content(0, "name", Fractions[i][Name], g_SQL, 32);
	        cache_get_field_content(0, "rank1", Rank_Name[i][0], g_SQL, 32);
	        cache_get_field_content(0, "rank2", Rank_Name[i][1], g_SQL, 32);
	        cache_get_field_content(0, "rank3", Rank_Name[i][2], g_SQL, 32);
	        cache_get_field_content(0, "rank4", Rank_Name[i][3], g_SQL, 32);
	        cache_get_field_content(0, "rank5", Rank_Name[i][4], g_SQL, 32);
	        cache_get_field_content(0, "rank6", Rank_Name[i][5], g_SQL, 32);
	        cache_get_field_content(0, "rank7", Rank_Name[i][6], g_SQL, 32);
	        cache_get_field_content(0, "rank8", Rank_Name[i][7], g_SQL, 32);
	        cache_get_field_content(0, "rank9", Rank_Name[i][8], g_SQL, 32);
	        cache_get_field_content(0, "rank10", Rank_Name[i][9], g_SQL, 32);
	        cache_get_field_content(0, "rank11", Rank_Name[i][10], g_SQL, 32);
	        cache_get_field_content(0, "rank12", Rank_Name[i][11], g_SQL, 32);
	        cache_get_field_content(0, "rank13", Rank_Name[i][12], g_SQL, 32);
         	cache_get_field_content(0, "spawn", spawn, g_SQL, 128);
         	cache_get_field_content(0, "skins", skins, g_SQL, 128);
	        sscanf (spawn, "p<,>fffi",
				Fractions[i][SpawnCoords][0],Fractions[i][SpawnCoords][1],Fractions[i][SpawnCoords][2],Fractions[i][Interior]);
            sscanf (skins, "p<,>iiiiiiiiiiiii",
				Fractions[i][Skin][0],Fractions[i][Skin][1],Fractions[i][Skin][2],Fractions[i][Skin][3],
				Fractions[i][Skin][4],Fractions[i][Skin][5],Fractions[i][Skin][6],Fractions[i][Skin][7],
				Fractions[i][Skin][8],Fractions[i][Skin][9],Fractions[i][Skin][10],Fractions[i][Skin][11],
				Fractions[i][Skin][12]);
	    }
	    printf (" : %d", i);
	}
	return 1;
}

stock PayDay(playerid){
	if (Player [playerid] [IsLoggedIn] == false) return 0;
	new temp[124];
	SendClientMessage(playerid, -1, "{71D177}         _____________________");
	format(temp, sizeof(temp), "{46B34D}           %i:00", g_Current_Hour);
	SendClientMessage(playerid, -1, temp);
    SendClientMessage(playerid, -1, "{71D177}         _____________________");
    Player[playerid][Exp]++;
	if(Player[playerid][Exp] >= Player[playerid][Level] * 8){
		SendClientMessage(playerid, 0x11206472,
			"!   .");
		SetPlayerScore(playerid, Player[playerid][Level]++);
		Player[playerid][Exp] = 1;
	}
	return 1;
}

stock CheckTime () {
	new l_Hour;
	gettime (l_Hour);
	if ((l_Hour > g_Current_Hour) || (l_Hour == 0 && g_Current_Hour == 23)){
		gettime(g_Current_Hour);
		SetWorldTime(g_Current_Hour);
		for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
		    if (Player [i] [IsLoggedIn] == true)
	 			PayDay(i);
		}
	}
}

stock GiveMoney (playerid, money) {
	Player[playerid][Money] += money;
	GivePlayerMoney(playerid, money);
}

public SecondTimer () {
    CheckTime ();
	for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
        if (GetPlayerMoney (i) != Player[i][Money]) {
			ResetPlayerMoney(i);
			GivePlayerMoney(i, Player[i][Money]);
		}
    }
	return 1;
}

public OnPlayerCommandReceived (playerid, cmdtext[])
{
    if(Player[playerid][IsLoggedIn] == false) {
        SendClientMessage(playerid, -1,
			" ");
        return 0;
    }
    return 1;
}

stock ProxDetector(Float:radius = 30.0, playerid, text[], col = 0xFFFFFFFF) {
    new Float:x, Float:y, Float:z;
    GetPlayerPos(playerid, x, y, z);
    for(new i = GetMaxPlayers() - 1, Float:dist, virtualworld = GetPlayerVirtualWorld(playerid), interior = GetPlayerInterior(playerid); i != -1; i--)
    {
        if(!IsPlayerConnected(i) || IsPlayerNPC(i) || virtualworld != GetPlayerVirtualWorld(i) || interior != GetPlayerInterior(i)) continue;
        dist = GetPlayerDistanceFromPoint(i, x, y, z);
        if(dist < radius) SendClientMessage(i, col, text);
    }
    return 1;
}

/*COMMANDS*/
CMD:checkreg (playerid, params []) {
	if (!params [0]) {
		mysql_tquery(g_SQL,
			"SELECT `username` FROM `players` WHERE `rpstatus` = '0' LIMIT 1",
			"OnPlayerCheckRPTest", "dd",
			playerid, 0);
	    return 1;
	} else {
		new query [256];
		mysql_format(g_SQL, query, sizeof(query),
			"SELECT `question_1`, `question_2`, `question_3`, `question_4`, `question_5`, `question_6` FROM `players` WHERE `username` = '%e' LIMIT 1",
			params);
		mysql_tquery(g_SQL, query,
			"OnPlayerCheckRPTest", "dd",
			playerid, 1);
	    return 1;
	}
}

CMD:activate (playerid, params []) {
	if (Player [playerid] [Admin] > 1) {
		new name [MAX_PLAYER_NAME];
	    if (sscanf(params, "s[32]", name)) {
			return SendClientMessage (playerid, -1,
			    " /activate Account_Name");
	    }

		new query [256];
		mysql_format(g_SQL, query, sizeof(query),
			"SELECT `username` FROM `players` WHERE `username` = '%e' LIMIT 1",
			name);
		mysql_tquery(g_SQL, query,
			"OnAccountChangeStatus", "dd",
			playerid, 1);
	}
	return 1;
}

CMD:deactivate (playerid, params []) {
	if (Player [playerid] [Admin] > 1 && params[0]) {
		new name [MAX_PLAYER_NAME];
	    if (sscanf(params, "s[32]", name)) {
			return SendClientMessage (playerid, -1,
			    " /deactivate Account_Name");
	    }
		new query [256];
		mysql_format(g_SQL, query, sizeof(query),
			"SELECT `username` FROM `players` WHERE `username` = '%e' LIMIT 1",
			name);
		mysql_tquery(g_SQL, query,
			"OnAccountChangeStatus", "dd",
			playerid, 2);
	}
	return 1;
}

CMD:spawnchange (playerid, params []) {
	if (Player [playerid] [Member] > 0) {
		new string [128];
		format (string, sizeof (string),
		    "    %s", ((g_Spawn_Change{playerid} = !g_Spawn_Change{playerid}) == 0) ? ("   .") :
		    ("  ."));
		SendClientMessage (playerid, -1,
			string);
	}
	return 1;
}

CMD:stats(playerid, params[])
{
	new caption[64];
	new text[512];
	#define HR "{336633}________________________________________________________{ffffff}\n"
	format(caption, sizeof(caption),
		"{336633}  :{ffffff} %s",
		Player[playerid][Name]);
 	format(text, sizeof (text),
	 	""HR"{99CC99}\n\t:\t\t\t\t%s\n\n\t:\t\t\t\t%s\n\t:\t\t\t%i\n\t :\t\t\t%i  %i\n"HR"",
 		Player[playerid][Name], (Player[playerid][Sex] == 2) ? ("") : (""), Player[playerid][Level],
 		Player[playerid][Exp], Player[playerid][Level] * 8);
 	#undef HR
	ShowPlayerDialog(playerid, DIALOG_UNUSED, DIALOG_STYLE_MSGBOX,
		caption, text,
		"", "");
	return 1;
}

CMD:a(playerid, params[]) {
	if (Player [playerid][Admin] > 0) {
		if (!params[0])
		    return SendClientMessage (playerid, -1,
		        " /a text");
		new string [128];
		format (string, sizeof (string),
			CHAT_YELLOW "[%s] " CHAT_WHITE "%s: %s",
			g_Admin_Rank_Names [Player [playerid] [Admin] - 1], Player [playerid][Name], params);
		for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
		    if (Player [i] [Admin] > 0) {
		        SendClientMessage (i, -1,
		            string);
		    }
		}
	}
	return 1;
}

CMD:setadmin (playerid, params[]) {
	if (Player [playerid] [Admin] == 3) {
	    if (sscanf (params, "dd", params [0], params [1]))
	        return SendClientMessage (playerid, -1,
	            " /setadmin id level (0-3)");
		if (params [1] < 0 || params [1] > 3)
		    return SendClientMessage (playerid, -1,
		        "      0   3");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		format (string, sizeof (string),
		    "   %s %d  .", Player [params [0]][Name], params [1]);
		SendClientMessage (playerid, -1,
			string);
			
        format (string, sizeof (string),
		    " %s   %d  .", Player [playerid][Name], params [1]);
		SendClientMessage (params [0], -1,
		    string);

		Player [params [0]] [Admin] = params [1];
	}
	return 1;
}

CMD:setleader (playerid, params[]) {
	if (Player [playerid] [Admin] == 3) {
	    if (sscanf (params, "dd", params [0], params [1]))
	        return SendClientMessage (playerid, -1,
	            " /setleader id fraction");
		if (params [1] < 0 || params [1] > 1)
		    return SendClientMessage (playerid, -1,
		        "      0   1");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		format (string, sizeof (string),
		    "   %s  %d.", Player [params [0]][Name], params [1]);
		SendClientMessage (playerid, -1,
			string);

        format (string, sizeof (string),
		    " %s    %d.", Player [playerid][Name], params [1]);
		SendClientMessage (params [0], -1,
		    string);

		Player [params [0]] [Leader] = params [1];
		Player [params [0]] [Member] = params [1];
		Player [params [0]] [Rank] = (params [1] == 0) ? 0 : 13;
		SpawnPlayer (params [0]);
	}
	return 1;
}

CMD:setlevel (playerid, params[]) {
	if (Player [playerid] [Admin] == 3) {
	    if (sscanf (params, "dd", params [0], params [1]))
	        return SendClientMessage (playerid, -1,
	            " /setlevel id level");
		if (params [1] < 1)
		    return SendClientMessage (playerid, -1,
		        "     1.");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		format (string, sizeof (string),
		    "   %s %d .", Player [params [0]][Name], params [1]);
		SendClientMessage (playerid, -1,
			string);

        format (string, sizeof (string),
		    " %s   %d .", Player [playerid][Name], params [1]);
		SendClientMessage (params [0], -1,
		    string);

		Player [params [0]] [Level] = params [1];
	}
	return 1;
}

CMD:setexp (playerid, params[]) {
	if (Player [playerid] [Admin] == 3) {
	    if (sscanf (params, "dd", params [0], params [1]))
	        return SendClientMessage (playerid, -1,
	            " /setexp id level");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		format (string, sizeof (string),
		    "   %s %d exp.", Player [params [0]][Name], params [1]);
		SendClientMessage (playerid, -1,
			string);

        format (string, sizeof (string),
		    " %s   %d exp.", Player [playerid][Name], params [1]);
		SendClientMessage (params [0], -1,
		    string);

		Player [params [0]] [Exp] = params [1];
	}
	return 1;
}

CMD:warn (playerid, params[]) {
	if (Player [playerid] [Admin] > 1) {
	    if (sscanf (params, "d", params[0]))
	        return SendClientMessage (playerid, -1,
	            " /warn playerid");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		if (Player [params [0]][Warn]++ < 3) {
			format (string, sizeof (string),
			    "   %s .     (%d/3)",
			    Player [params [0]][Name], Player [params [0]][Warn]);
			SendClientMessage (playerid, -1,
			    string);
			format (string, sizeof (string),
			    " %s   .   (%d/3)",
			    Player [playerid][Name], Player [params [0]][Warn]);
			SendClientMessage (params[0], -1,
			    string);
		} else {
		    SendClientMessage (playerid, -1,
		        "   (3-) ,       7 .");
		    SendClientMessage (params[0], -1,
		        "   (3-) ,       7 .");
			Player [params [0]][Warn] = 0;
			new query [256];
			mysql_format(g_SQL, query, sizeof(query),
				"INSERT INTO `banlist`(`name`, `bantime`, `unbantime`, `reason`, `playerban`) VALUES ('%e', '%d', '%d', '3 Warns', '%e')",
				Player [params [0]][Name], gettime(), gettime() + (86400 * 7), Player [playerid][Name]);
			mysql_tquery(g_SQL, query);
	    	DelayedKick(params[0]);
		}
	}
	return 1;
}

CMD:unwarn (playerid, params[]) {
	if (Player [playerid] [Admin] > 1) {
	    if (sscanf (params, "d", params[0]))
	        return SendClientMessage (playerid, -1,
	            " /unwarn playerid");
		if (Player [params[0]][IsLoggedIn] == false)
		    return SendClientMessage (playerid, -1,
		        "  !");
		new string [128];
		if (Player [params [0]][Warn]-- >= 0) {
			format (string, sizeof (string),
			    "   %s  .     (%d/3)",
			    Player [params [0]][Name], Player [params [0]][Warn]);
			SendClientMessage (playerid, -1,
			    string);
			format (string, sizeof (string),
			    " %s     .   (%d/3)",
			    Player [playerid][Name], Player [params [0]][Warn]);
			SendClientMessage (params[0], -1,
			    string);
		} else {
			SendClientMessage (playerid, -1,
			    "      ()");
		}
	}
	return 1;
}

CMD:pay(playerid, params[]) {
	if (sscanf(params, "ui", params[0], params[1]))
		return SendClientMessage(playerid, -1,
			": /pay [id ] []");
	if (Player [playerid] [IsLoggedIn] == false)
	    return SendClientMessage(playerid, -1,
			"  .");
	if (params[1] < 1 || params[1] > 100000)
		return SendClientMessage(playerid, -1,
			" .");
			
	new Float:x, Float:y, Float:z;
	GetPlayerPos(params[0], x, y, z);
	if (!IsPlayerInRangeOfPoint(playerid, 8.0, x, y, z))
		return SendClientMessage(playerid, -1,
			"  !");
	if (params[1] > Player[playerid][Money])
		return SendClientMessage(playerid, -1,
			" !");
	GiveMoney(playerid, -params[1]);
	GiveMoney(params[0], params[1]);
	new string[128];
	format(string, sizeof(string),
		"{ffffff}  {CC0000}%i${ffffff}  {6699FF}%s (ID:%i).",
		params[1], Player[params[0]][Name], params[0]);
	SendClientMessage(playerid, -1,
		string);
	format(string, sizeof(string),
		"{6699FF}%s (ID:%i){FFFFFF}   {009933}%i$.",
		Player[playerid][Name], playerid, params[1]);
	SendClientMessage(params[0], -1,
		string);
	PlayerPlaySound(playerid,
		1052, 0.0, 0.0, 0.0);
	PlayerPlaySound(params[0],
		1052, 0.0, 0.0, 0.0);
	return 1;
}

CMD:invite (playerid, params[]) {
    if (Player[playerid][Leader] > 0) {
		if (sscanf (params, "i", params[0]))
		    return SendClientMessage (playerid, -1,
		        " /invite playerid");
		if (Player [params[0]][Member] != 0)
		    return SendClientMessage (playerid, -1,
		        "    !");
		new string [128];
		format (string, sizeof (string),
		    " %s     %d!",
			Player [playerid][Name], Player[playerid][Member]);
		SendClientMessage (params[0], -1,
		    string);
		format (string, sizeof (string),
		    "  %s  !",
			Player [params[0]][Name]);
		SendClientMessage (playerid, -1,
		    string);
		Player[params[0]][Member] = Player[playerid][Member];
		Player[params[0]][Rank] = 1;
		SetPlayerSkin (params[0],
			Fractions[Player [params[0]][Member] - 1][Skin][Player[params[0]][Rank] - 1]);
	}
	return 1;
}

CMD:uninvite (playerid, params[]) {
	if (Player[playerid][Leader] > 0) {
		if (sscanf (params, "i", params[0]))
		    return SendClientMessage (playerid, -1,
		        " /uninvite playerid");
		if (Player [params[0]][Member] != Player[playerid][Member])
		    return SendClientMessage (playerid, -1,
		        "     !");
		new string [128];
		format (string, sizeof (string),
		    " %s    !",
			Player [playerid][Name]);
		SendClientMessage (params[0], -1,
		    string);
		format (string, sizeof (string),
		    "  %s  !",
			Player [params[0]][Name]);
		SendClientMessage (playerid, -1,
		    string);
		Player[params[0]][Member] = 0;
		Player[params[0]][Rank] = 0;
	}
	return 1;
}

CMD:giverank (playerid, params []) {
	if (Player[playerid][Leader] > 0) {
	    if (sscanf (params, "ii", params[0], params[1]))
		    return SendClientMessage (playerid, -1,
		        " /giverank playerid rank");
		if (params[1] < 1 || params[1] > 13)
		    return SendClientMessage (playerid, -1,
		        "      1   13!");
		if (Player [params[0]][Member] != Player[playerid][Member])
		    return SendClientMessage (playerid, -1,
		        "     !");
		new string [128];
		format (string, sizeof (string),
		    " %s   %d !",
			Player [playerid][Name], params[1]);
		SendClientMessage (params[0], -1,
		    string);
		format (string, sizeof (string),
		    "  %s %d !",
			Player [params[0]][Name], params[1]);
		SendClientMessage (playerid, -1,
		    string);
		Player[params[0]][Rank] = params[1];
		SetPlayerSkin (params[0],
			Fractions[Player [params[0]][Member] - 1][Skin][Player[params[0]][Rank] - 1]);
	}
	return 1;
}

CMD:members (playerid, params []) {
    if (Player[playerid][Leader] > 0) {
        SendClientMessage(playerid, -1,
            "  :");
		for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
            if (Player [i] [IsLoggedIn] == true) {
                if (Player [i] [Member] == Player [playerid][Member]) {
                    SendClientMessage (playerid, -1,
                        Player[i][Name]);
                }
            }
        }
    }
	return 1;
}

CMD:r(playerid, params[]) {
	if (Player [playerid][Member] > 0) {
	    if (!params[0])
	        return SendClientMessage (playerid, -1,
	            " /r text");
		new string [128];
		format (string, sizeof (string),
		    "[%s] %s: %s",
		    Rank_Name [Player [playerid][Member] - 1][Player [playerid][Rank] - 1], Player [playerid][Name], params[0]);
		for(new x, i = g_Players[x]; x < g_Players_Count; i = g_Players[++x]) {
		    if (Player[i][Member] == Player[playerid][Member]) {
		        SendClientMessage (i, -1,
		            string);
		    }
		}
	}
	return 1;
}

CMD:b (playerid, params []) {
	if (!params[0])
	    return SendClientMessage (playerid, -1,
	        " /b text");
	new string [128];
	format (string, sizeof (string),
	    "%s : (( %s ))",
	    Player [playerid][Name], params [0]);
    ProxDetector(10.0, playerid, string, 0xE6E6E6E6);
	return 1;
}

CMD:ban(playerid, params[]) {
	if (Player [playerid] [Admin] > 1) {
		if (sscanf (params,"uis[64]", params[0], params[1], params[2]))
			return SendClientMessage(playerid, -1,
				" /ban [id] [()] []");
	    if(Player [params[0]][IsLoggedIn] == false)
			return SendClientMessage(playerid, -1,
				"  !");
	    if (params[1] < 1 || params[1] > 365)
			return SendClientMessage(playerid, -1,
				"     1  365.");
	    new string[128];
	    format (string, sizeof(string),
			" %s  %s  %d %s. : %s",
			Player [playerid][Name], Player [params [0]][Name], params[1], (params[1] == 1) ? ("") : (params[1] < 5) ? ("") : (""), params[2]);
		SendClientMessageToAll (-1,
		    string);
		new query [256];
		mysql_format(g_SQL, query, sizeof(query),
			"INSERT INTO `banlist` (`name`, `bantime`, `unbantime`, `reason`, `playerban`) VALUES ('%s', '%d', '%d', '%s', '%s')",
			Player [params [0]][Name], gettime(), gettime() + (86400 * params [1]), params [2], Player [playerid][Name]);
		mysql_tquery(g_SQL, query);
	    DelayedKick(params[0]);
    }
    return 1;
}

CMD:unban (playerid, params []) {
	if (Player [playerid] [Admin] > 1) {
	    if (sscanf (params, "s[64]", params [0]))
			return SendClientMessage (playerid, -1,
			    " /unban Player_Name");
		new query [128];
        mysql_format(g_SQL, query, sizeof(query), "SELECT `name` FROM `banlist` WHERE `name` = '%e' LIMIT 1", params [0]);
		mysql_tquery(g_SQL, query, "OnCheckPlayerBan", "dd", playerid, 1);
	}
	return 1;
}
/*END_SCRIPT*/
